// to make the proc_macros work inside the microrm crate; needed for tests and the metaschema.
extern crate self as microrm;

pub mod db;
pub mod entity;
mod query;
pub mod schema;

pub mod prelude {
    pub use microrm_macros::{Database, Entity};
    // pub use crate::entity::
}

// ----------------------------------------------------------------------
// Generically-useful database types
// ----------------------------------------------------------------------

#[derive(Debug)]
pub enum DBError {
    EmptyResult,
    LogicError(&'static str),
    Sqlite(sqlite::Error),
}

impl From<sqlite::Error> for DBError {
    fn from(value: sqlite::Error) -> Self {
        Self::Sqlite(value)
    }
}

/*
pub enum DBResult<T> {
    Ok(T),
    Empty,
    Error(sqlite::Error),
}

impl<T> DBResult<T> {
    pub fn empty_ok(self) -> Result<Option<T>, DBError> {
        match self {
            Self::Ok(t) => Ok(Some(t)),
            Self::Empty => Ok(None),
            Self::Error(err) => Err(DBError::Sqlite(err)),
        }
    }

    pub fn empty_err(self) -> Result<T, DBError> {
        match self {
            Self::Ok(t) => Ok(t),
            Self::Empty => Err(DBError::EmptyResult),
            Self::Error(err) => Err(DBError::Sqlite(err)),
        }
    }
}

impl<T> From<Option<T>> for DBResult<T> {
    fn from(value: Option<T>) -> Self {
        match value {
            Some(v) => Self::Ok(v),
            None => Self::Empty,
        }
    }
}
*/
pub type DBResult<T> = Result<T, DBError>;
